import networkx as nx
import argparse
import string
import os

def gml_to_adjlist(input, output):
    G = nx.read_gml(input)
    with open(output, 'w') as op:
        for line in nx.generate_adjlist(G):
            lst = string.split(line, ' ')
            for tgt in lst[1:]:
                op.write("".join([lst[0], ' ' , tgt, '\n']))

if __name__ == '__main__':

    parser = argparse.ArgumentParser()  
    parser.add_argument("input_file", help="Specify the path of the input data set")
    parser.add_argument("output_file", help="Specify the path of the output data set")
    args = parser.parse_args()

    if os.path.isfile(args.input_file):
        gml_to_adjlist(args.input_file, args.output_file)
